import { ethers } from 'ethers';
/**
 * The config object.
 * This object should not be manipulated directly, and is exported mostly for debug purposes.
 */
export declare const config: {
    provider: any;
    multicall: any;
    network: any;
    subgraphUrl: any;
    gnosisUrl: any;
    etherscanUrl: any;
    etherscanApiKey: any;
};
/**
 * Initializes the SDK. This should be called on app startup.
 * @param input.network - Network ID. Currently supporting Mainnet (id 1) and Goerli (id 5)
 * @param input.subgraphUrl - Optional override for development/debug purposes.
 */
export declare function init(input: {
    provider: ethers.providers.Provider;
    network: number;
    subgraphUrl?: string;
}): void;
