import { ethers } from 'ethers';
import ENS from '@ensdomains/ensjs';
/**
 * Returns Controller, ENS Name and pod ID for a given pod address.
 * @param address Pod address
 */
export declare function getPodFetchersByAddressOrEns(identifier: string): Promise<{
    podId: number;
    Safe: ethers.Contract;
    Controller: ethers.Contract;
    Name: ENS.Name;
}>;
/**
 * Returns Controller, ENS Name and pod ID for a given pod id
 * @param id - pod ID
 */
export declare function getPodFetchersById(id: number): Promise<{
    podId: number;
    Safe: ethers.Contract;
    Controller: ethers.Contract;
    Name: ENS.Name;
}>;
